#include <cstdio>
#include <cstdlib>
#include <cstring>
#include "SparseFilter.h"
#include "IioImage.h"

using sparse_filter::IioImage;
using sparse_filter::SparseFilter;

// c: pointer to original argc
// v: pointer to original argv
// o: option name after hyphen
// d: default value (if NULL, the option takes no argument)
const char *pick_option(int *c, char **v, const char *o, const char *d) {
    int id = d ? 1 : 0;
    for (int i = 0; i < *c - id; i++) {
        if (v[i][0] == '-' && 0 == strcmp(v[i] + 1, o)) {
            char *r = v[i + id] + 1 - id;
            for (int j = i; j < *c - id; j++)
                v[j] = v[j + id + 1];
            *c -= id + 1;
            return r;
        }
    }
    return d;
}

int main(int argc, char *argv[]) {
    if (argc < 5) {
        fprintf(stderr, "too few parameters\n");
        fprintf(stderr, "usage: %s input sigma_d sigma_r output [-r r] [-t threshold]\n", argv[0]);
        return 1;
    }
    IioImage source(argv[1]);
    IioImage output;
    float sigma_d = atof(argv[2]);
    float sigma_r = atof(argv[3]);
    int r = atoi(pick_option(&argc, argv, "r", "-1"));
    if (r == -1) r = int(3 * sigma_d);
    float threshold = atof(pick_option(&argc, argv, "t", "1"));
    
    // Ce qui m'intéresse :
    // SparseFilter(source, sigma_d * sigma_d, sigma_r * sigma_r, r, threshold, &output);
    
    /*
     * Ma fonction, pas encore prête.
     */
    BilateralFilter(source, sigma_d * sigma_d, sigma_r * sigma_r, r, &output);
    
    
    output.Save(argv[4]);
    return 0;
}
